e6_siruco/urls.py
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('main.urls')),
    path('', include('hanif.urls')),
    path('authentication/', include('authentication.urls')),
    path('transaksi-makan/', include('transaksi_makan.urls')),
    path('paket-makan/', include('paket_makan.urls')),
    path('hotel/', include('hotel.urls')),
    path('jadwal-dokter/', include('jadwal_dokter.urls')),
    path('daftar-pasien/', include('daftar_pasien.urls')),
    path('appointment/', include('appointment.urls')),
    path('faskes/', include('faskes.urls')),
    path('jadwal_faskes/', include('jadwal_faskes.urls')),
    path('rumahsakit/', include('rumahsakit.urls')),
    path('reservasiRS/', include('reservasiRS.urls')),
    path('transaksirs/', include('transaksirs.urls')),
    path('ruangan-rs/', include('ruangan_rs.urls')),
]

faskes/urls.py
from django.urls import path

from .views import delete_faskes, read_faskes, detail_faskes, update_faskes, create_faskes
app_name = 'faskes'

urlpatterns = [
    path('create/', create_faskes, name='create'),
    path('read/', read_faskes, name='read'),
    path('details/', detail_faskes, name='details'),
    path('update/', update_faskes, name='update'),
    path('delete/', delete_faskes, name='delete'),
]

main/urls.py
from django.urls import path

from . import views

app_name = 'main'

urlpatterns = [
    path('', views.home, name='home'),
]

faskes/models.py
from django.db import models

# Create your models here.

faskes/forms.py
from django import forms
from django.db import connection


class CreateFaskesForm(forms.Form):
    tipe_faskes_list = [('Rumah Sakit', 'Rumah Sakit'),
                        ('Puskesmas', 'Puskesmas'), ('Klinik', 'Klinik')]
    status_faskes_list = [('Swasta', 'Swasta'), ('Pemerintah', 'Pemerintah')]
    kode = forms.CharField(label=("Kode Faskes"), required=True, max_length=3)
    tipe = forms.ChoiceField(
        label=('Tipe'), required=True, choices=tipe_faskes_list)
    nama = forms.CharField(label=("Nama Faskes"), required=True, max_length=50)
    status = forms.ChoiceField(
        label=('Status Kepemilikan'), required=True, choices=status_faskes_list)
    jalan = forms.CharField(label=("Jalan"), required=True, max_length=30)
    kelurahan = forms.CharField(
        label=("Kelurahan"), required=True, max_length=30)
    kecamatan = forms.CharField(
        label=("Kecamatan"), required=True, max_length=30)
    kabkot = forms.CharField(label=("Kabupaten/Kota"),
                             required=True, max_length=30)
    provinsi = forms.CharField(
        label=("Provinsi"), required=True, max_length=30)

    def __init__(self, *args, **kwargs):
        super(CreateFaskesForm, self).__init__(*args, **kwargs)
        self.fields['kode'].widget.attrs['readonly'] = True
        new_code = ''
        with connection.cursor() as cursor:
            cursor.execute(
                "SELECT KODE FROM SIRUCO.FASKES ORDER BY KODE DESC LIMIT 1")
            new_code = 'F' + self.manipulation(cursor.fetchall()[0][0][1:])
        self.fields['kode'].initial = new_code

    def manipulation(self, kode):
        res = ''
        if kode[-1] == '9':
            res += str(int(kode[0])+1)
            res += '0'
        else:
            res += (kode[0] + str(int(kode[-1]) + 1))
        return res


class UpdateFaskesForm(forms.Form):
    tipe_faskes_list = [('Rumah Sakit', 'Rumah Sakit'),
                        ('Puskesmas', 'Puskesmas'), ('Klinik', 'Klinik')]
    status_faskes_list = [('Swasta', 'Swasta'), ('Pemerintah', 'Pemerintah')]
    kode = forms.CharField(label=("Kode Faskes"), required=True, max_length=3)
    tipe = forms.ChoiceField(
        label=('Tipe'), required=True, choices=tipe_faskes_list)
    nama = forms.CharField(label=("Nama Faskes"), required=True, max_length=50)
    status = forms.ChoiceField(
        label=('Status Kepemilikan'), required=True, choices=status_faskes_list)
    jalan = forms.CharField(label=("Jalan"), required=True, max_length=30)
    kelurahan = forms.CharField(
        label=("Kelurahan"), required=True, max_length=30)
    kecamatan = forms.CharField(
        label=("Kecamatan"), required=True, max_length=30)
    kabkot = forms.CharField(label=("Kabpuaten/Kota"),
                             required=True, max_length=30)
    provinsi = forms.CharField(
        label=("Provinsi"), required=True, max_length=30)

    def __init__(self, *args, **kwargs):
        super(UpdateFaskesForm, self).__init__(*args, **kwargs)
        self.fields['kode'].widget.attrs['readonly'] = True

faskes/views.py
from django.shortcuts import render

from django.shortcuts import render, redirect
from django.http import HttpResponseRedirect
from django.urls import reverse
from .forms import *
from django.db import connection
from e6_siruco.auth_decorator import require_login


@require_login
def create_faskes(request):
    if request.session.get('peran', False) == 'admin satgas':
        form = CreateFaskesForm()
        if request.method == "POST":
            kode = request.POST['kode']
            tipe = request.POST['tipe']
            nama = request.POST['nama']
            status = request.POST['status']
            jalan = request.POST['jalan']
            kelurahan = request.POST['kelurahan']
            kecamatan = request.POST['kecamatan']
            kabkot = request.POST['kabkot']
            provinsi = request.POST['provinsi']
            data_baru = [kode, tipe, nama, status, jalan,
                         kelurahan, kecamatan, kabkot, provinsi]
            with connection.cursor() as cursor:
                cursor.execute(
                    'INSERT INTO SIRUCO.FASKES VALUES (%s, %s, %s, %s, %s, %s, %s, %s, %s)', data_baru)
            return redirect('faskes:read')
        return render(request, 'faskes/buat-faskes.html', {'form': form, 'peran': request.session['peran']})


@require_login
def update_faskes(request):
    if request.session.get('peran', False) == 'admin satgas':
        if request.method == 'GET':
            if request.GET.get('kode') is not None:
                kode = request.GET.get('kode')
                with connection.cursor() as cursor:
                    cursor.execute(
                        'SELECT * FROM SIRUCO.FASKES where kode=%s LIMIT 1;', [kode])
                    data = dictfetchall(cursor)
                data_faskes = {}
                data_faskes['kode'] = data[0]['kode']
                data_faskes['tipe'] = data[0]['tipe']
                data_faskes['nama'] = data[0]['nama']
                data_faskes['status'] = data[0]['statusmilik']
                data_faskes['jalan'] = data[0]['jalan']
                data_faskes['kelurahan'] = data[0]['kelurahan']
                data_faskes['kecamatan'] = data[0]['kecamatan']
                data_faskes['kabkot'] = data[0]['kabkot']
                data_faskes['provinsi'] = data[0]['prov']
                form = UpdateFaskesForm(initial=data_faskes)
        else:
            kode = request.POST['kode']
            tipe = request.POST['tipe']
            nama = request.POST['nama']
            status = request.POST['status']
            jalan = request.POST['jalan']
            kelurahan = request.POST['kelurahan']
            kecamatan = request.POST['kecamatan']
            kabkot = request.POST['kabkot']
            provinsi = request.POST['provinsi']
            data_baru = [tipe, nama, status, jalan,
                         kelurahan, kecamatan, kabkot, provinsi, kode]
            with connection.cursor() as cursor:
                cursor.execute(
                    "UPDATE SIRUCO.FASKES SET tipe = %s, nama = %s,statusmilik = %s,jalan = %s,kelurahan = %s,kecamatan = %s,kabkot = %s,prov = %s WHERE KODE = %s", data_baru)
            return redirect('faskes:read')
        return render(request, 'faskes/update-faskes.html', {'form': form})


@require_login
def delete_faskes(request):
    if request.session.get('peran', False) == 'admin satgas':
        if request.method == 'GET':
            if request.GET.get('kode') is not None:
                kode_faskes = request.GET.get('kode')
                with connection.cursor() as cursor:
                    cursor.execute(
                        'DELETE FROM SIRUCO.FASKES WHERE kode = %s', [kode_faskes])
        return HttpResponseRedirect(reverse('faskes:read'))


@require_login
def read_faskes(request):
    if request.session.get('peran', False) == 'admin satgas':
        with connection.cursor() as cursor:
            cursor.execute("SELECT * FROM SIRUCO.FASKES")
            seluruh = dictfetchall(cursor)
        context = {'fsk': seluruh}
        return render(request, 'faskes/read-faskes.html', context)


@require_login
def detail_faskes(request):
    if request.session.get('peran', False) == 'admin satgas':
        if request.method == 'GET':
            if request.GET.get('kode') is not None:
                kode_faskes = request.GET.get('kode')
                with connection.cursor() as cursor:
                    cursor.execute(
                        'SELECT * FROM SIRUCO.FASKES where kode=%s LIMIT 1;', [kode_faskes])
                    data = dictfetchall(cursor)

        return render(request, 'faskes/detil-faskes.html', data[0])


def dictfetchall(cursor):
    columns = [col[0] for col in cursor.description]
    return [
        dict(zip(columns, row))
        for row in cursor.fetchall()
    ]

faskes/templates/faskes/buat-faskes.html
{% extends 'base.html' %}

{% block meta %}
{% endblock meta %}

{% block content %}



<h1 style="text-align: center;">FORM BUAT FASILITAS KESEHATAN</h1>

<form action="" method="POST">
    {% csrf_token %}
    {{form.as_p}}
    <input type="submit" value="Submit">
</form>



{% endblock content %}

faskes/templates/faskes/detil-faskes.html
{% extends 'base.html' %}

{% block meta %}
{% endblock meta %}

{% block content %}



<h1 class="text-center">DATA FASILITAS KESEHATAN</h1>
<table class="table">
    <tbody>
        <tr>
            <th scope="row">Kode Faskes</th>
            <td>{{kode}}</td>

        </tr>
        <tr>
            <th scope="row">Tipe</th>
            <td>{{tipe}}</td>

        </tr>
        <tr>
            <th scope="row">Nama Faskes</th>
            <td>{{nama}}</td>
        </tr>
        <tr>
            <th scope="row">Status Kepemilikan</th>
            <td>{{statusmilik}}</td>
        </tr>
        <tr>
            <th scope="row">Jalan </th>
            <td>{{jalan}}</td>
        </tr>
        <tr>
            <th scope="row">Kelurahan </th>
            <td>{{kelurahan}}</td>
        </tr>
        <tr>
            <th scope="row">Kecamatan </th>
            <td>{{kecamatan}}</td>
        </tr>
        <tr>
            <th scope="row">Kabupaten/Kota </th>
            <td>{{kabkot}}</td>
        </tr>
        <tr>
            <th scope="row">Provinsi </th>
            <td>{{prov}}</td>
        </tr>

    </tbody>
</table>
<div style="display: flex;justify-content:center;align-items:center">
    <button class="btn btn-warning"><a href="{% url 'faskes:read'%}">Kembali</a></button>
</div>


{% endblock content %}

faskes/templates/faskes/read-faskes.html
{% extends 'base.html' %}

{% block meta %}
{% endblock meta %}


{% block content %}


<h1 class="text-center">Daftar faskes</h1>
<table class="table">
    <thead>
        <tr>
            <th scope="col">Kode Faskes</th>
            <th scope="col">Tipe</th>
            <th scope="col">Nama Faskes</th>
            {% if request.session.peran == 'admin satgas' %}
            <th scope="col"></th>
            <th scope="col"></th>
            <th scope="col"></th>
            {% endif %}
        </tr>
    </thead>
    <tbody>

        {% for fk in fsk %}
        <tr>

            <td>{{ fk.kode }}</td>
            <td>{{ fk.tipe }}</td>
            <td>{{ fk.nama }}</td>
            {% if request.session.peran == 'admin satgas' %}
            <td>
                <form action="{% url 'faskes:update' %}" method="get">
                    <input type="hidden" id="kode" name="kode" value="{{ fk.kode }}">
                    <button type="submit" class="btn btn-outline-warning">Update</button>
                </form>
            </td>
            <td>

                <form action="{% url 'faskes:delete' %}" method="get">
                    <input type="hidden" id="kode" name="kode" value="{{ fk.kode }}">
                    <button type="submit" class="btn btn-outline-danger">Delete</button>
                </form>
            </td>
            <td>
                <form action="{% url 'faskes:details' %}" method="get">
                    <input type="hidden" id="kode" name="kode" value="{{ fk.kode }}">
                    <button type="submit" class="btn btn-outline-primary">Detail</button>
                </form>
            </td>
            </td>
            {% endif %}
        </tr>

        {% endfor %}

    </tbody>
</table>


{% endblock content %}

faskes/templates/faskes/update-faskes.html
{% extends 'base.html' %}

{% block meta %}
{% endblock meta %}

{% block content %}

<h1 style="text-align: center;">FORM UBAH FASILITAS KESEHATAN</h1>
<div style="height: 20px;"></div>
<form action="{% url 'faskes:update' %}" method="POST">
    {% csrf_token %}
    {{form.as_p}}
    <button type="submit" class="btn btn-primary">Update</button>
</form>


{% endblock content %}